// $FlowExpectedError: Pending proper flow types
import { useEffect, useState } from 'react';
import firebase from 'firebase/app';
import 'firebase/database';
import { isString } from '../util';
export default (function (pathOrRef) {
  var ref = isString(pathOrRef) ? firebase.database().ref(pathOrRef) : pathOrRef;

  var _useState = useState(false),
      error = _useState[0],
      setError = _useState[1];

  var _useState2 = useState(true),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = useState(undefined),
      value = _useState3[0],
      setValue = _useState3[1];

  var onError = function onError(err) {
    setError(err);
    setLoading(false);
  };

  var onSnapshot = function onSnapshot(snapshot) {
    setValue(snapshot);
    setLoading(false);
  };

  useEffect(function () {
    ref.on('value', onSnapshot, onError);
    return function () {
      ref.off('value', onSnapshot);
    };
  }, // TODO: Check if this works suitably for 'ref' parameters
  [pathOrRef]);
  return {
    error: error,
    loading: loading,
    value: value
  };
});